"""first_revision

迁移 ID: 94353282a8c6
父迁移:
创建时间: 2024-11-20 16:30:02.583631

"""

from __future__ import annotations

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op

revision: str = "94353282a8c6"
down_revision: str | Sequence[str] | None = None
branch_labels: str | Sequence[str] | None = ("nonebot_plugin_pcr_sign",)
depends_on: str | Sequence[str] | None = None


def upgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "sign_albums",
        sa.Column("gid", sa.Integer(), nullable=False),
        sa.Column("uid", sa.Integer(), nullable=False),
        sa.Column("stamp_id", sa.Integer(), nullable=False),
        sa.Column("collected", sa.Boolean(), nullable=False),
        sa.PrimaryKeyConstraint("gid", "uid", "stamp_id", name=op.f("pk_sign_albums")),
        info={"bind_key": "nonebot_plugin_pcr_sign"},
    )
    op.create_table(
        "sign_users",
        sa.Column("gid", sa.Integer(), nullable=False),
        sa.Column("uid", sa.Integer(), nullable=False),
        sa.Column("affection", sa.Integer(), nullable=False),
        sa.Column("last_sign", sa.Date(), nullable=False),
        sa.PrimaryKeyConstraint("gid", "uid", name=op.f("pk_sign_users")),
        info={"bind_key": "nonebot_plugin_pcr_sign"},
    )
    # ### end Alembic commands ###


def downgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("sign_users")
    op.drop_table("sign_albums")
    # ### end Alembic commands ###
